Getting Started

The React ListBox control contains a list of selectable items. It performs exceptionally well with thousands of items and supports checkboxes, template, single and multiple selection, keyboard navigation and virtual scrolling.

Key Features

Data Binding: Supports Data binding with JSON data and remote data.

Multi Selection: Supports multiple selection of list items.

Virtual Scrolling: Provides support to load its data on demand through virtual scrolling which greatly improves the application’s performance.

Template Support: Support Template contents to render as list items

Grouping: Groups the set of list items with header

Cascading: To populate data in a ListBox based on the selection in another ListBox.

Drag and Drop: Supports drag and drop features for list items

This section helps to understand the getting started of the React ListBox with the step-by-step instructions.

Create an ListBox

You can create a React application and add necessary scripts and styles with the help of the given ReactJJs Getting Started Documentation.

Define an HTML element for adding ListBox in the application and refer the JSX file created.

  • HTML
  • <script src="scripts/sampledata.js"></script>
    <div id="listbox-default"></div>
    <script src="app/listbox/default.js"></script>

    To configure data for ListBox component, define data in an array and map corresponding fields to it.

  • JS
  • var BikeList = [
    { empid: "bk1", text: "Aache RTR" }, { empid: "bk2", text: "CBR 150-R" }, { empid: "bk3", text: "CBZ Xtreme" },
        { empid: "bk4", text: "Discover" }, { empid: "bk5", text: "Dazzler" }, { empid: "bk6", text: "Flame" },
        { empid: "bk7", text: "Fazzer" }, { empid: "bk8", text: "FZ-S" }, { empid: "bk9", text: "Pulsar" },
        { empid: "bk10", text: "Shine" }, { empid: "bk11", text: "R15" }, { empid: "bk12", text: "Unicorn" }
    ];
    
    window.listBoxFields = { id: "empid", value: "text" };

    Create a JSX file for rendering ListBox component using <EJ.ListBox> syntax. Add required properties to it in <EJ.ListBox> tag element

  • JS
  • "use strict";
    
    ReactDOM.render(
      <div>  
        <div className="lblTitle">Select a bike</div>
    <EJ.ListBox id="default" width="100%" dataSource={BikeList} fields={window.listBoxFields}>
        </EJ.ListBox>
      </div>,
    document.getElementById('listbox-default')
    );

    Run the above code to render the following output:

    Selection

    The React ListBox widget also supports the item selection.

    Use the following code render the ListBox with Selection

  • JS
  • "use strict";
    
    ReactDOM.render(
      <div>  
        <div className="lblTitle">Select a bike</div>
    <EJ.ListBox id="default" width="100%" dataSource={BikeList} fields={window.listBoxFields} selectedIndex=2>
        </EJ.ListBox>
      </div>,
    document.getElementById('listbox-default')
    );

    Run the above code to render the following output.

    Note: You can find the ListBox properties from the API reference document

Getting Started

17 Dec 20188 minutes to read

The Angular ListBox widget that contains a list of selectable items. It performs exceptionally well with thousands of items and supports checkboxes, template, single and multiple selection, keyboard navigation and virtual scrolling.

This section explains briefly about how to create a web ListBox in your application with Angular by step-by-step instructions

Create an ListBox widget in Angular

Create a new HTML file and include the below code:

  • HTML
  • <!DOCTYPE html>
    <html>
       <head> 
        <link href="//cdn.syncfusion.com/28.1.33/js/web/flat-azure/ej.web.all.min.css" rel="stylesheet" />
        <script src="node_modules/core-js/client/shim.min.js"></script>
        <script src="node_modules/zone.js/dist/zone.js"></script>
        <script src="node_modules/reflect-metadata/Reflect.js"></script>
        <script src="node_modules/systemjs/dist/system.src.js"></script>
        <script src="https://code.jquery.com/jquery-3.1.1.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js" type="text/javascript"></script>
        <script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.14.0/jquery.validate.min.js">
        </script>
            <script src="http://cdn.syncfusion.com/28.1.33/js/web/ej.web.all.min.js" type="text/javascript"></script>
        <script src ="http://cdn.syncfusion.com/28.1.33/js/common/ej.angular2.min.js"></script>
    
        <script src="systemjs.config.js"></script>
      </head>
      <body>
       <ej-app>Loading...</ej-app>
      </body>

    Create input element and add in the body tag as below.

  • HTML
  • <div class="container" style="padding-top:100px">
    
    <div class="row">
    <div class="ctrllabel" style="padding-bottom: 12px"><b>Select a car</b></div>
    
    <ej-listbox [dataSource]="data" [fields]="fieldList" > </ej-listbox>
            </div>
    </div>

    To render the Angular ListBox use the below code.

  • JS
  • import {Component,NgModule} from '@angular/core';
    import {FormsModule} from '@angular/forms';
    import {BrowserModule} from '@angular/platform-browser';
    
    @Component({
      selector: 'home',
      templateUrl: 'app/app.component.html',
     styles: [
         ".e-listbox.e-ul li { height: 25px; padding-top: 6px;  }"
      ],
      encapsulation: ViewEncapsulation.None,
    })
    export class AppComponent {
        data:array;
        fieldList:object;
        value:string;
        constructor() {
        this.data=[
            { employeeId: "cr1", text: "Dodge Avenger", value: "Dodge Avenger" },
            { employeeId: "cr2", text: "Chrysler 200", value: "Chrysler 200" },
            { employeeId: "cr3", text: "Ford Focus", value: "Ford Focus" },
            { employeeId: "cr4", text: "Ford Taurus", value: "Ford Taurus" },
            { employeeId: "cr5", text: "Dazzler", value: "Dazzler" },
            { employeeId: "cr6", text: "Chevy Spark", value: "Chevy Spark" },
            { employeeId: "cr7", text: "Chevy Volt", value: "Chevy Volt" },
            { employeeId: "cr8", text: "Honda Fit", value: "Honda Fit" },
            { employeeId: "cr9", text: "Honda Cross tour", value: "Honda Cross tour" },
            { employeeId: "cr10", text: "Hyundai Elantra", value: "Hyundai Elantra" },
            { employeeId: "cr11", text: "Mazda3", value: "Mazda3" }
        ];
        this.fieldList={dataSource:this.data,text:"text",value:"value"};
        }
    }

    Run the above code to render the following output.

    Getting Started

    Model binding

    The Angular ListBox supports the data binding feature. When a widget’s model attribute is bound to ngModel variable, it will be reflected the changes.

    The below table depicts the properties of ListBox widget that supports model binding:

    control Supported properties
    ejListbox [`valuedataSource`]

    Add in the ngModel value as below.

  • HTML
  • <div class="container" style="padding-top:100px">
    <div class="row">
    <div class="ctrllabel" style="padding-bottom: 12px"><b>Select a car</b></div>
    <ej-listbox [dataSource]="data" [fields]="fieldList" [value]="value" > </ej-listbox>
                   <br/>
    <div id="binding">
                      <input type="text" id="listValue" class="input ejinputtext" [(ngModel)]="value" />
                 </div>
            </div>
    </div>
  • JS
  • import {Component,NgModule} from '@angular/core';
    import {FormsModule} from '@angular/forms';
    import {BrowserModule} from '@angular/platform-browser';
    
    @Component({
       selector: 'ej-app',    
      templateUrl: 'app/app.component.html',
    })
    
    export class AppComponent {
       data:array;
        fieldList:object;
        value:string;
        constructor() {
        this.data=[
            { employeeId: "cr1", text: "Dodge Avenger", value: "Dodge Avenger" },
            { employeeId: "cr2", text: "Chrysler 200", value: "Chrysler 200" },
            { employeeId: "cr3", text: "Ford Focus", value: "Ford Focus" },
            { employeeId: "cr4", text: "Ford Taurus", value: "Ford Taurus" },
            { employeeId: "cr5", text: "Dazzler", value: "Dazzler" },
            { employeeId: "cr6", text: "Chevy Spark", value: "Chevy Spark" },
            { employeeId: "cr7", text: "Chevy Volt", value: "Chevy Volt" },
            { employeeId: "cr8", text: "Honda Fit", value: "Honda Fit" },
            { employeeId: "cr9", text: "Honda Cross tour", value: "Honda Cross tour" },
            { employeeId: "cr10", text: "Hyundai Elantra", value: "Hyundai Elantra" },
            { employeeId: "cr11", text: "Mazda3", value: "Mazda3" }
        ];
        this.fieldList={text:"text"};
        this.value="Mazda3";
        }
    }

    Run the above code to render the following output.

    Model binding

    Enable Selection

    The selection property is used to render the ListBox list item by Selection.

  • HTML
  • <div class="container" style="padding-top:100px">
    
    <div class="row">
    <div class="ctrllabel" style="padding-bottom: 12px"><b>Select a car</b></div>
    
    <ej-listbox [dataSource]="data" [fields]="fieldList" [selectedIndex]="4" > </ej-listbox>
    
            </div>
    </div>

    Run the above code to render the following output.

    Enable Selection